package ubiik.utils;

import java.util.ArrayList;
import javafx.scene.paint.Color;
import javafx.util.Pair;

public class GradientColorManager {
  private String[] rgbHexColrs;
  
  private ArrayList<Pair<Float, Color>> percentColors;
  
  private int minValue;
  
  private int maxValue;
  
  public GradientColorManager(int minValue, int maxValue) {
    this.maxValue = maxValue;
    this.minValue = minValue;
    this.percentColors = new ArrayList<>();
    this.percentColors.add(new Pair<>(Float.valueOf(0.0F), Color.RED));
    this.percentColors.add(new Pair<>(Float.valueOf(0.5F), Color.YELLOW));
    this.percentColors.add(new Pair<>(Float.valueOf(1.0F), Color.GREEN));
    int totalColors = maxValue - minValue + 1;
    this.rgbHexColrs = new String[totalColors];
    for (int p = 0; p < totalColors; p++) {
      float pct = (maxValue - minValue - p) / totalColors;
      System.out.println(pct);
      int i = 1;
      boolean found = false;
      while (!found) {
        if (pct <= ((Float)((Pair)this.percentColors.get(i)).getKey()).floatValue()) {
          found = true;
          continue;
        } 
        i++;
      } 
      Pair<Float, Color> lower = this.percentColors.get(i - 1);
      Pair<Float, Color> upper = this.percentColors.get(i);
      float range = ((Float)upper.getKey()).floatValue() - ((Float)lower.getKey()).floatValue();
      float rangePct = (pct - ((Float)lower.getKey()).floatValue()) / range;
      float pctLower = 1.0F - rangePct;
      float pctUpper = rangePct;
      int red = (int)(255.0D * (((Color)lower.getValue()).getRed() * pctLower + ((Color)upper.getValue()).getRed() * pctUpper));
      int green = (int)(255.0D * (((Color)lower.getValue()).getGreen() * pctLower + ((Color)upper.getValue()).getGreen() * pctUpper));
      int blue = (int)(255.0D * (((Color)lower.getValue()).getBlue() * pctLower + ((Color)upper.getValue()).getBlue() * pctUpper));
      this.rgbHexColrs[totalColors - 1 - p] = intToHexStr(red) + intToHexStr(red) + intToHexStr(green);
    } 
  }
  
  public static String intToHexStr(int i) {
    return String.format("%2s", new Object[] { Integer.toHexString(i) }).replace(' ', '0');
  }
  
  public String getColorForValue(int value) {
    value = (value > this.maxValue) ? this.maxValue : ((value < this.minValue) ? this.minValue : value);
    return this.rgbHexColrs[value - this.minValue];
  }
}
