package ubiik.utils;

import org.json.simple.JSONObject;

public class JsonUtils {
  public static byte[] getByteArr(JSONObject json, String key) {
    Object obj = json.get(key);
    if (obj != null)
      return DatatypeConverter.parseHexBinary((String)obj); 
    return null;
  }
  
  public static Object getIfExists(JSONObject json, String key) {
    if (json.containsKey(key))
      return json.get(key); 
    return null;
  }
  
  public static Integer getIntIfExists(JSONObject json, String key) {
    Long l = (Long)getIfExists(json, key);
    if (l != null)
      return Integer.valueOf(l.intValue()); 
    return null;
  }
  
  public static Long getLongIfExists(JSONObject json, String key) {
    return (Long)getIfExists(json, key);
  }
  
  public static Byte getByteIfExists(JSONObject json, String key) {
    Long l = (Long)getIfExists(json, key);
    if (l != null)
      return Byte.valueOf(l.byteValue()); 
    return null;
  }
}
