package ubiik.utils.files;

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

public class FileUtils {
  public static int countLinesInFile(File file) throws IOException {
    InputStream is = new BufferedInputStream(new FileInputStream(file));
    try {
      byte[] c = new byte[1024];
      int count = 0;
      int readChars = 0;
      boolean endsWithoutNewLine = false;
      while ((readChars = is.read(c)) != -1) {
        for (int i = 0; i < readChars; i++) {
          if (c[i] == 10)
            count++; 
        } 
        endsWithoutNewLine = (c[readChars - 1] != 10);
      } 
      if (endsWithoutNewLine)
        count++; 
      return count;
    } finally {
      is.close();
    } 
  }
  
  public static byte[] toByteArray(InputStream in) throws IOException {
    ByteArrayOutputStream os = new ByteArrayOutputStream();
    byte[] buffer = new byte[1024];
    int len;
    while ((len = in.read(buffer)) != -1)
      os.write(buffer, 0, len); 
    return os.toByteArray();
  }
  
  public static byte[] toByteArray(File file) throws IOException {
    FileInputStream fis = new FileInputStream(file);
    byte[] data = toByteArray(fis);
    fis.close();
    return data;
  }
}
