package ubiik.utils.view;

import java.text.Format;
import javafx.scene.control.Label;
import javafx.scene.control.TableCell;
import javafx.scene.control.TableColumn;
import javafx.util.Callback;

public class ColumnFormatter<S, T> implements Callback<TableColumn<S, T>, TableCell<S, T>> {
  private Format format;
  
  public ColumnFormatter(Format format) {
    this.format = format;
  }
  
  public TableCell<S, T> call(TableColumn<S, T> arg0) {
    return new TableCell<S, T>() {
        protected void updateItem(T item, boolean empty) {
          super.updateItem(item, empty);
          if (item == null || empty) {
            setGraphic(null);
          } else {
            setGraphic(new Label(ColumnFormatter.this.format.format(item)));
          } 
        }
      };
  }
}
