package ubiik.wp.admin;

import javafx.fxml.FXMLLoader;
import javafx.stage.Stage;
import ubiik.wp.admin.model.fpga.AdminFPGARegisterFactory;
import ubiik.wp.admin.model.sdr.AdminSDRParameterFactory;
import ubiik.wp.admin.psconnection.auth.PSAuthAdmin;
import ubiik.wp.admin.view.AdminMainViewController;
import ubiik.wp.controller.DevicesController;
import ubiik.wp.controller.MessageController;
import ubiik.wp.controller.UserManager;
import ubiik.wp.model.fpga.FPGARegisterFactory;
import ubiik.wp.model.sdr.SDRParameterFactory;
import ubiik.wp.psconnection.auth.PSAuth;
import ubiik.wp.view.BaseApplication;
import ubiik.wp.view.ConnectionManagerViewController;

public class AdminMain extends BaseApplication {
  protected void doSetUpMainController(Stage stage, DevicesController dc, MessageController mc) {
    this.mainLoader = new FXMLLoader(getClass().getResource("/main/resources/ubiik/wp/admin/MainView.fxml"));
    this.mainController = (ConnectionManagerViewController)new AdminMainViewController(stage, mc, dc);
    this.mainLoader.setController(this.mainController);
  }

  protected static void setUpUserManager() {
    UserManager usrManager = UserManager.getInstance();
    usrManager.setPsAuth((PSAuth)new PSAuthAdmin());
    usrManager.setFpgaRegisterFactory((FPGARegisterFactory)new AdminFPGARegisterFactory());
    usrManager.setSdrParameterFactory((SDRParameterFactory)new AdminSDRParameterFactory());
  }

  public static void main(String[] args) {
    setUpUserManager();
    launch(args);
  }
}
