package ubiik.wp.ami.controller;

import org.json.simple.JSONObject;
import ubiik.wp.ami.model.AMIMessage;
import ubiik.wp.ami.model.AmiMeterDiscovery;
import ubiik.wp.ami.model.AmiMeterKeys;

public class AMIDiscoveryTest extends AMITest {
  public AMIDiscoveryTest(FANTestController fanController, JSONObject json, int endpoint) {
    super(fanController, json, endpoint);
  }
  
  public UUTestResult run() {
    AmiMeterKeys meterKeys = new AmiMeterKeys(AMIMessage.Direction.out, new byte[16], new byte[16]);
    this.fanController.sendAmiMessage((AMIMessage)meterKeys, this.fan, this.endpoint);
    long timeout = 10000L;
    byte expectedAssocStatus = 1;
    AMIMessage amiMsg = this.fanController.getAMIMessage(timeout, (byte)-96, null);
    UUTestResult testResult = new UUTestResult(false, "");
    if (amiMsg != null) {
      AmiMeterDiscovery discovery = (AmiMeterDiscovery)amiMsg;
      if (discovery.getAmiAssocStatus() == expectedAssocStatus) {
        testResult.setSuccess(true);
      } else {
        testResult.setMessage("Expected Discovery with AssocStatus " + expectedAssocStatus + " but received " + discovery.getAmiAssocStatus());
      } 
    } else {
      testResult.setMessage("No Discovery received within " + timeout + "ms");
    } 
    return null;
  }
}
