package ubiik.wp.ami.controller;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Calendar;
import org.json.simple.JSONObject;
import ubiik.wp.ami.model.AMIMessage;
import ubiik.wp.ami.model.AmiComparisonResult;
import ubiik.wp.ami.model.AmiResponse;

public class AmiTestTime extends AMITest {
  public static final byte[] dateTimeobis = new byte[] { 0, 0, 1, 0, 0, -1 };
  
  public AmiTestTime(FANTestController fanController, JSONObject json, int endpoint) {
    super(fanController, json, endpoint);
  }
  
  protected void analyzeResponse(AMIMessage msg, AMIMessage resp, StringBuilder sb, UUTestResult testResult) {
    System.out.println("analyzeResponse in AmiTestTime");
    sb.append("Received ").append(resp.getClass().getSimpleName()).append("\n");
    if (resp instanceof AmiResponse && this.lastSentMessage instanceof ubiik.wp.ami.model.AmiGet) {
      Calendar now = Calendar.getInstance();
      Calendar timeInResp = Calendar.getInstance();
      AmiResponse amiResp = (AmiResponse)resp;
      ByteBuffer buf = ByteBuffer.wrap(amiResp.getAxdr()).order(ByteOrder.BIG_ENDIAN);
      timeInResp.set(buf.getShort(5), buf.get(7) - 1, buf.get(8), buf.get(10), buf.get(11), buf.get(12));
      if (this.lastSentMessageTime != null) {
        System.out.println("this.lastSentMessageTime " + this.lastSentMessageTime.getTime());
        System.out.println("now " + now.getTime());
        System.out.println("timeInResp " + timeInResp.getTime());
        long lngTimeInResp = timeInResp.getTimeInMillis();
        boolean compResult = (lngTimeInResp >= this.lastSentMessageTime.getTimeInMillis() && lngTimeInResp <= now.getTimeInMillis());
        testResult.setSuccess(compResult);
        if (!compResult)
          sb.append("Expected time between ").append(this.lastSentMessageTime.getTime()).append(" and ")
            .append(now.getTime()).append(" but received: ").append(timeInResp.getTime()).append("\n"); 
      } else {
        sb.append("Missing previous message. ");
        testResult.setSuccess(false);
      } 
    } else {
      AmiComparisonResult compRes = msg.amiCompare(resp);
      if (!compRes.equal) {
        sb.append(compRes.message);
        testResult.setSuccess(false);
      } 
    } 
  }
}
