package ubiik.wp.ami.controller;

import org.json.simple.JSONObject;
import ubiik.wp.ami.model.AMIMessage;
import ubiik.wp.ami.model.AmiComparisonResult;
import ubiik.wp.ami.model.AmiXanLog;

public class AmiXanLogTest extends AMITest {
  private AmiXanLog prevLog;
  
  public AmiXanLogTest(FANTestController fanController, JSONObject json, int endpoint) {
    super(fanController, json, endpoint);
    this.prevLog = null;
  }
  
  protected void analyzeResponse(AMIMessage msg, AMIMessage resp, StringBuilder sb, UUTestResult testResult) {
    sb.append("Received ").append(resp.getClass().getSimpleName()).append("\n");
    if (resp instanceof AmiXanLog) {
      if (this.prevLog != null) {
        AmiComparisonResult compRes = resp.amiCompare((AMIMessage)this.prevLog);
        if (!compRes.equal) {
          sb.append(compRes.message);
          testResult.setSuccess(false);
        } 
      } 
      this.prevLog = (AmiXanLog)resp;
    } else {
      AmiComparisonResult compRes = msg.amiCompare(resp);
      if (!compRes.equal) {
        sb.append(compRes.message);
        testResult.setSuccess(false);
      } 
    } 
  }
}
