package ubiik.wp.ami.model;

import org.json.simple.JSONObject;
import ubiik.utils.JsonUtils;

public class AmiGetXanLog extends AMIMessage {
  private static final int XAN_ID_SIZE = 1;
  
  private byte xanId;
  
  public AmiGetXanLog(byte[] bytes) {
    super(bytes);
    if (bytes.length < 3)
      throw new IllegalArgumentException("Data is too small for AmiGetXanLog"); 
    this.xanId = bytes[2];
  }
  
  public AmiGetXanLog(JSONObject json) {
    super(json);
    this.xanId = JsonUtils.getByteIfExists(json, "xanId").byteValue();
    try {
      this.payload.write(this.xanId);
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  protected AmiComparisonResult doAmiCompare(AMIMessage other) {
    return new AmiComparisonResult(false, "Not implemented. Meant to be sent not received");
  }
}
