package ubiik.wp.ami.model;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import org.json.simple.JSONObject;
import ubiik.utils.JsonUtils;

public class DLMSObis {
  public static final int DLMS_OBIS_SIZE = 6;
  
  private Byte a;
  
  private Byte b;
  
  private Byte c;
  
  private Byte d;
  
  private Byte e;
  
  private Byte f;
  
  private ByteBuffer buf;
  
  public DLMSObis(ByteBuffer buffer) {
    loadFromBuffer(buffer);
  }
  
  public DLMSObis(JSONObject json) {
    byte[] data = JsonUtils.getByteArr(json, "obisCode");
    ByteBuffer buffer = ByteBuffer.wrap(data).order(ByteOrder.LITTLE_ENDIAN);
    loadFromBuffer(buffer);
  }
  
  private void loadFromBuffer(ByteBuffer buffer) {
    this.buf = buffer;
    try {
      this.a = Byte.valueOf(this.buf.get());
      this.b = Byte.valueOf(this.buf.get());
      this.c = Byte.valueOf(this.buf.get());
      this.d = Byte.valueOf(this.buf.get());
      this.e = Byte.valueOf(this.buf.get());
      this.f = Byte.valueOf(this.buf.get());
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }
  
  public byte[] getPayload() {
    return this.buf.array();
  }
  
  public Byte getA() {
    return this.a;
  }
  
  public Byte getB() {
    return this.b;
  }
  
  public Byte getC() {
    return this.c;
  }
  
  public Byte getD() {
    return this.d;
  }
  
  public Byte getE() {
    return this.e;
  }
  
  public Byte getF() {
    return this.f;
  }
}
