package ubiik.wp.app.core;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.Date;
import ubiik.wp.model.messages.PSUplink;

public class UplinkSampleHeader {
  public static final short BYTES_FOR_SAMPLE_HEADER = 6;
  
  private byte applicationType;
  
  private byte applicationSubType;
  
  protected Date timestamp = null;
  
  public UplinkSampleHeader(PSUplink uplink) {
    byte[] data = uplink.getApplicationData();
    try {
      ByteBuffer buffer = ByteBuffer.wrap(data).order(ByteOrder.LITTLE_ENDIAN);
      this.applicationType = buffer.get();
      this.applicationSubType = buffer.get();
      long intSampleTime = buffer.getInt();
      this.timestamp = new Date(intSampleTime * 1000L);
    } catch (Exception e) {
      throw new IllegalArgumentException("Invalid Sample");
    } 
  }
  
  public synchronized byte getApplicationType() {
    return this.applicationType;
  }
  
  public synchronized void setApplicationType(byte applicationType) {
    this.applicationType = applicationType;
  }
  
  public synchronized byte getApplicationSubType() {
    return this.applicationSubType;
  }
  
  public synchronized void setApplicationSubType(byte applicationSubType) {
    this.applicationSubType = applicationSubType;
  }
  
  public synchronized Date getTimestamp() {
    return this.timestamp;
  }
  
  public synchronized void setTimestamp(Date timestamp) {
    this.timestamp = timestamp;
  }
}
