package ubiik.wp.controller;

import com.opencsv.bean.CsvToBeanBuilder;
import java.io.FileReader;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import ubiik.wp.util.ApplicationLogger;

public class EndDeviceNameAndIdxManager {
  private Map<String, String> edNames = new HashMap<>();
  
  private Map<String, Integer> edIdx = new HashMap<>();
  
  private Integer maxIdx = Integer.valueOf(-1);
  
  private static class Holder {
    static final EndDeviceNameAndIdxManager INSTANCE = new EndDeviceNameAndIdxManager();
  }
  
  public static EndDeviceNameAndIdxManager getInstance() {
    return Holder.INSTANCE;
  }
  
  public void loadNamesFromPath(String path) {
    try {
      this.edNames.clear();
      List<CSVDevice> beans = (new CsvToBeanBuilder(new FileReader(path))).withType(CSVDevice.class).build().parse();
      for (int i = 0; i < beans.size(); i++) {
        CSVDevice ed = beans.get(i);
        this.edNames.put(ed.getUuid(), ed.getName());
        this.edIdx.put(ed.getUuid(), Integer.valueOf(i));
        Integer integer1 = this.maxIdx, integer2 = this.maxIdx = Integer.valueOf(this.maxIdx.intValue() + 1);
      } 
    } catch (Exception e) {
      ApplicationLogger.debug("Failed to load Base Station names");
    } 
  }
  
  public String getNameForUUID(String uuid) {
    return this.edNames.get(uuid.replaceAll("-", ""));
  }
  
  public String getNameForUUIDOrUUID(String uuid) {
    String name = getNameForUUID(uuid);
    if (name == null)
      name = uuid; 
    return name;
  }
  
  public String getUUIDForName(String name) {
    String key = null;
    for (Map.Entry<String, String> entry : this.edNames.entrySet()) {
      if (((String)entry.getValue()).equals(name)) {
        key = entry.getKey();
        break;
      } 
    } 
    return key;
  }
  
  public Map<String, String> getKeysAndNames() {
    return new HashMap<>(this.edNames);
  }
  
  public Map<String, Integer> getDevicesAndIndexes() {
    return new HashMap<>(this.edIdx);
  }
  
  public Integer getIndexForUUEID(String uuid) {
    return this.edIdx.get(uuid);
  }
  
  public int getMaxIndex() {
    return this.maxIdx.intValue();
  }
  
  private EndDeviceNameAndIdxManager() {}
}
