package ubiik.wp.controller;

import ubiik.wp.model.devices.UUEndDevice;
import ubiik.wp.model.messages.pscommands.PSCommandMCSSetting;
import ubiik.wp.model.messages.pscommands.PSCommandMCSValue;
import ubiik.wp.model.messages.pscommands.responses.PSCommandResponseMCSSetting;
import ubiik.wp.model.messages.pscommands.responses.PSCommandResponseMCSValue;

public class MCSController {
  private DevicesController devicesController;
  
  public MCSController(DevicesController devicesController) {
    this.devicesController = devicesController;
  }
  
  public synchronized void processMCSCommandResponse(PSCommandMCSSetting cmd) {
    short dlVal = -1;
    short ulVal = -1;
    if (cmd.isGet()) {
      dlVal = ((PSCommandResponseMCSSetting)cmd.getResponse()).getDownlinkVal();
      ulVal = ((PSCommandResponseMCSSetting)cmd.getResponse()).getUplinkVal();
    } else {
      dlVal = cmd.getDownlinkVal();
      ulVal = cmd.getUplinkVal();
    } 
    UUEndDevice ed = this.devicesController.getDeviceForId(cmd.getUueid());
    if (ed != null)
      ed.setMCSFlags(ulVal, dlVal); 
  }
  
  public synchronized void processMCSValuesCommandResponse(PSCommandMCSValue cmd) {
    byte dlVal = -1;
    byte ulVal = -1;
    byte ulValNB = -1;
    if (cmd.isGet()) {
      dlVal = ((PSCommandResponseMCSValue)cmd.getResponse()).getDownlinkMCSValue();
      ulVal = ((PSCommandResponseMCSValue)cmd.getResponse()).getUplinkMCSValue();
      ulValNB = ((PSCommandResponseMCSValue)cmd.getResponse()).getUplinkMCSValueNB();
    } else {
      dlVal = cmd.getDownlinkMCSValue();
      ulVal = cmd.getUplinkMCSValue();
      ulValNB = cmd.getUplinkMCSValueNB();
    } 
    UUEndDevice ed = this.devicesController.getDeviceForId(cmd.getUueid());
    ed.setMCSValues(ulVal, dlVal, ulValNB);
  }
}
