package ubiik.wp.controller;

import ubiik.wp.model.bsparameters.BSParameterFactory;
import ubiik.wp.model.fpga.FPGARegisterFactory;
import ubiik.wp.model.sdr.SDRParameterFactory;
import ubiik.wp.psconnection.auth.PSAuth;
import ubiik.wp.psconnection.auth.PSAuthClient;

public class UserManager {
  private PSAuth psAuth = (PSAuth)new PSAuthClient();
  
  private FPGARegisterFactory fpgaRegisterFactory = new FPGARegisterFactory();
  
  private BSParameterFactory bsParamFactory = new BSParameterFactory();
  
  private SDRParameterFactory sdrParameterFactory = new SDRParameterFactory();
  
  private static class Holder {
    static final UserManager INSTANCE = new UserManager();
  }
  
  public static UserManager getInstance() {
    return Holder.INSTANCE;
  }
  
  public synchronized PSAuth getPsAuth() {
    return this.psAuth;
  }
  
  public synchronized void setPsAuth(PSAuth psAuth) {
    this.psAuth = psAuth;
  }
  
  public synchronized FPGARegisterFactory getFpgaRegisterFactory() {
    return this.fpgaRegisterFactory;
  }
  
  public synchronized void setFpgaRegisterFactory(FPGARegisterFactory fpgaRegisterFactory) {
    this.fpgaRegisterFactory = fpgaRegisterFactory;
  }
  
  public synchronized SDRParameterFactory getSdrParameterFactory() {
    return this.sdrParameterFactory;
  }
  
  public synchronized void setSdrParameterFactory(SDRParameterFactory sdrParameterFactory) {
    this.sdrParameterFactory = sdrParameterFactory;
  }
  
  public synchronized BSParameterFactory getBsParamFactory() {
    return this.bsParamFactory;
  }
  
  public synchronized void setBsParamFactory(BSParameterFactory bsParamFactory) {
    this.bsParamFactory = bsParamFactory;
  }
  
  private UserManager() {}
}
