package ubiik.wp.demo.model;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

public class PhySample extends SampleFromUplink {
  public static final int RSSI_SAMPLE_LENGTH = 13;
  
  private int packets;
  
  private int rssi;
  
  private int batteryVoltage;
  
  private int temperature;
  
  private Integer uplinkRssi;
  
  private Date uplinkTime;
  
  private Date sampleTime;
  
  public PhySample(String uuid, Date receivedTime, Integer uplinkRssi, int packets, int rssi, int batteryVoltage, int temperature, Date uplinkTime, Date sampleTime) {
    super(receivedTime, uuid);
    this.packets = packets;
    this.rssi = rssi;
    this.batteryVoltage = batteryVoltage;
    this.temperature = temperature;
    this.uplinkRssi = uplinkRssi;
    this.uplinkTime = uplinkTime;
    this.sampleTime = sampleTime;
  }
  
  public synchronized int getPackets() {
    return this.packets;
  }
  
  public synchronized void setPackets(int packets) {
    this.packets = packets;
  }
  
  public synchronized int getRssi() {
    return this.rssi;
  }
  
  public synchronized void setRssi(int rssi) {
    this.rssi = rssi;
  }
  
  public synchronized int getBatteryVoltage() {
    return this.batteryVoltage;
  }
  
  public synchronized void setBatteryVoltage(int battery) {
    this.batteryVoltage = battery;
  }
  
  public synchronized int getTemperature() {
    return this.temperature;
  }
  
  public synchronized void setTemperature(int temperature) {
    this.temperature = temperature;
  }
  
  public Date getUplinkTime() {
    return this.uplinkTime;
  }
  
  public String getUplinkTimeStr() {
    SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss yyyy-MM-dd", Locale.ENGLISH);
    return sdf.format(this.uplinkTime);
  }
  
  public String getSampleTimeStr() {
    SimpleDateFormat sdf = new SimpleDateFormat("HH:mm:ss yyyy-MM-dd", Locale.ENGLISH);
    return sdf.format(this.sampleTime);
  }
  
  public Date getSampleTime() {
    return this.sampleTime;
  }
  
  public String toString() {
    return "Phy Sample [rssi: " + this.rssi + ", packets: " + this.packets + ", battery [V]: " + this.batteryVoltage + ", temperature: " + this.temperature + ", timestamp " + this.timestamp + "]";
  }
  
  public Integer getUplinkRssi() {
    return this.uplinkRssi;
  }
  
  public String getUplinkRssiStr() {
    if (this.uplinkRssi == null)
      return "-"; 
    return Integer.toString(this.uplinkRssi.intValue());
  }
  
  public void setUplinkRssi(Integer uplinkRssi) {
    this.uplinkRssi = uplinkRssi;
  }
  
  public void setUplinkTime(Date uplinkTime) {
    this.uplinkTime = uplinkTime;
  }
  
  public void setSampleTime(Date sampleTime) {
    this.sampleTime = sampleTime;
  }
}
