package ubiik.wp.model.capacity;

import ubiik.wp.controller.DevicesController;
import ubiik.wp.controller.MessageController;
import ubiik.wp.model.devices.UUEndDevice;

public class MessageCapacityTestFactory {
  public static final MessageCapacityTest createTest(int interval, int dataSize, UUEndDevice endDevice, int channel, MessageController messageController, DevicesController devicesController, int totalMsgs) {
    MessageCapacityTest mct = null;
    if (interval > Integer.MAX_VALUE || interval < 1000)
      throw new IllegalArgumentException("Invalid interval"); 
    if (dataSize > 4096 || dataSize < 0)
      throw new IllegalArgumentException("Invalid data size"); 
    if (totalMsgs < 0 || totalMsgs > Integer.MAX_VALUE)
      throw new IllegalArgumentException("Invalid total messages"); 
    if (channel == 2) {
      mct = new ControlCapacityTest(interval, dataSize, endDevice, messageController, devicesController.getPingManager(), totalMsgs);
    } else if (channel == 0 || channel == 1) {
      int endpoint = (channel == 0) ? 1 : 0;
      mct = new DownlinkCapacityTest(interval, dataSize, endDevice, endpoint, messageController, totalMsgs);
    } else {
      throw new IllegalArgumentException("Invalid channel");
    } 
    return mct;
  }
}
