package ubiik.wp.model.devices;

import org.apache.commons.lang3.BooleanUtils;

public class ScheduleTransferConfig {
  private byte flag = 0;
  
  private int interval = 0;
  
  private int window = 0;
  
  public static final int INTERVAL_NO_VALUE = 0;
  
  public static final int INTERVAL_MIN_VALUE = 2;
  
  public static final int INTERVAL_MAX_VALUE = 1024;
  
  public static final int WINDOW_NO_VALUE = 0;
  
  public static final int WINDOW_MIN_VALUE = 2;
  
  public static final int WINDOW_MAX_VALUE = 1024;
  
  public static final byte FLAG_ST_RELEASE = 0;
  
  public static final byte FLAG_ST_SET = 1;
  
  public static boolean validateWindow(int window) {
    return (window >= 2 && window <= 1024);
  }
  
  public static boolean validateInterval(int interval) {
    return (interval >= 2 && interval <= 1024);
  }
  
  public static boolean validateIntervalVsWindow(int interval, int window) {
    return (window <= interval);
  }
  
  public synchronized boolean setStatus(byte flag, int window, int interval) {
    boolean i = false;
    boolean valid = (flag == 0 || flag == 1);
    if (valid) {
      this.flag = flag;
      if (flag == 0) {
        this.interval = 0;
        this.window = 0;
      } else if (flag == 1) {
        i = valid & validateInterval(interval) & validateWindow(window) & validateIntervalVsWindow(interval, window);
        if (i != false) {
          this.interval = interval;
          this.window = window;
        } 
      } 
    } 
    return i;
  }
  
  public synchronized byte getFlag() {
    return this.flag;
  }
  
  public synchronized int getWindow() {
    return this.window;
  }
  
  public synchronized int getInterval() {
    return this.interval;
  }
}
