package ubiik.wp.model.devices;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class UUSIB1 {
  private static final int UUSIB1_MIN_BYTES = 5;
  
  public static final int HOP_FIRST_CH_MIN = 0;
  
  public static final int HOP_FIRST_CH_MAX = 10000;
  
  private short hop_first_ch;
  
  public static final int HOP_CH_SPACING_MIN = 0;
  
  public static final int HOP_CH_SPACING_MAX = 255;
  
  private short hop_ch_spacing;
  
  public static final int HOP_CH_NB_MIN = 0;
  
  public static final int HOP_CH_NB_MAX = 63;
  
  private short hop_ch_nb;
  
  public static final int NB_NCELL_HOP_MIN = 0;
  
  public static final int NB_NCELL_HOP_MAX = 6;
  
  private short nb_ncell_hop_ch;
  
  public static final int NCELL_CH_MIN = 0;
  
  public static final int NCELL_CH_MAX = 10000;
  
  public static final int BYTES_PER_NB_CELL_CH = 2;
  
  private short[] ncell_ch;
  
  public UUSIB1(short hop_first_ch, short hop_last_ch, short hop_ch_nb, short nb_ncell_hop_ch, short[] ncell_ch) {
    this.hop_first_ch = hop_first_ch;
    this.hop_ch_spacing = hop_last_ch;
    this.hop_ch_nb = hop_ch_nb;
    this.nb_ncell_hop_ch = nb_ncell_hop_ch;
    this.ncell_ch = ncell_ch;
  }
  
  public synchronized short getHop_first_ch() {
    return this.hop_first_ch;
  }
  
  public synchronized boolean setHop_first_ch(short hop_first_ch) {
    if (hop_first_ch >= 0 && hop_first_ch <= 10000) {
      this.hop_first_ch = hop_first_ch;
      return true;
    } 
    return false;
  }
  
  public synchronized short getHop_ch_spacing() {
    return this.hop_ch_spacing;
  }
  
  public synchronized boolean setHop_ch_spacing(short hop_ch_spacing) {
    if (hop_ch_spacing >= 0 && hop_ch_spacing <= 255) {
      this.hop_ch_spacing = hop_ch_spacing;
      return true;
    } 
    return false;
  }
  
  public synchronized short getHop_ch_nb() {
    return this.hop_ch_nb;
  }
  
  public synchronized boolean setHop_ch_nb(short hop_ch_nb) {
    if (hop_ch_nb >= 0 && hop_ch_nb <= 63) {
      this.hop_ch_nb = hop_ch_nb;
      return true;
    } 
    return false;
  }
  
  public synchronized short getNb_ncell_hop_ch() {
    return this.nb_ncell_hop_ch;
  }
  
  public synchronized boolean setNb_ncell_hop_ch(short nb_ncell_hop_ch) {
    if (nb_ncell_hop_ch >= 0 && nb_ncell_hop_ch <= 6) {
      this.nb_ncell_hop_ch = nb_ncell_hop_ch;
      return true;
    } 
    return false;
  }
  
  public synchronized short[] getNcell_ch() {
    return this.ncell_ch;
  }
  
  public synchronized boolean setNcell_ch(short[] ncell_ch) {
    boolean valid = true;
    for (int i = 0; i < ncell_ch.length; i++)
      valid = (valid && ncell_ch[i] >= 0 && ncell_ch[i] <= 10000); 
    if (valid)
      this.ncell_ch = ncell_ch; 
    return valid;
  }
  
  public int getSize() {
    return 5 + this.ncell_ch.length * 2;
  }
  
  public byte[] getData() {
    ByteBuffer buffer = ByteBuffer.allocate(getSize()).order(ByteOrder.LITTLE_ENDIAN);
    buffer.putShort(this.hop_first_ch);
    buffer.put((byte)(0xFF & this.hop_ch_spacing));
    buffer.put((byte)(0xFF & this.hop_ch_nb));
    buffer.put((byte)(0xFF & this.nb_ncell_hop_ch));
    for (int i = 0; i < this.ncell_ch.length; i++)
      buffer.putShort(this.ncell_ch[i]); 
    return buffer.array();
  }
}
