package ubiik.wp.model.messages;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import ubiik.wp.model.atcommand.ATCommand;

public final class PSDownlinkATCommand extends PSDownlink {
  private static final byte AT_DOWNLINK_LEADING_BYTE = -3;
  
  private PSDownlinkATCommand(int applicationID, byte[] messageData, byte[] target, int endpoint) {
    super(applicationID, messageData, target, endpoint);
  }
  
  private PSDownlinkATCommand(int applicationID, byte[] messageData, byte[] target) {
    super(applicationID, messageData, target);
  }
  
  private PSDownlinkATCommand(byte[] messageData, byte[] target, int endpoint) {
    super(messageData, target, endpoint);
  }
  
  private PSDownlinkATCommand(byte[] messageData, byte[] target) {
    super(messageData, target);
  }
  
  public static byte[] createDownlinkATData(String atCommand) {
    byte[] atCmdDownlikData = null;
    String standardAtCmd = ATCommand.standarizeATCommand(atCommand) + "\r";
    if (standardAtCmd.startsWith("AT")) {
      byte[] strData = standardAtCmd.getBytes();
      ByteBuffer buffer = ByteBuffer.allocate(1 + strData.length).order(ByteOrder.LITTLE_ENDIAN);
      buffer.put((byte)-3);
      buffer.put(strData);
      atCmdDownlikData = buffer.array();
    } 
    return atCmdDownlikData;
  }
}
