package ubiik.wp.model.messages;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSHardwareInfo extends PSMessage {
  private byte[] hash;
  
  public PSHardwareInfo(int messageId, byte[] messageData) {
    super(messageId, 0, messageData, (byte)14);
    ByteBuffer buffer = ByteBuffer.wrap(this.data).order(ByteOrder.LITTLE_ENDIAN);
    int headerSize = buffer.getInt();
    int payloadSize = buffer.getInt();
    if (buffer.remaining() != headerSize + payloadSize)
      throw new IllegalArgumentException("Invalid header and payload size"); 
    this.hash = new byte[payloadSize];
    this.protocolVersion = buffer.getInt();
    buffer.position(headerSize + 8);
    buffer.get(this.hash);
  }
  
  protected byte[] getMessageDataBytes() throws MessageFormatException {
    return this.data;
  }
}
