package ubiik.wp.model.messages;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.charset.StandardCharsets;

public class PSLogMessage extends PSMessage {
  private short source;
  
  private String message;
  
  public PSLogMessage(int messageId, int applicationID, byte[] messageData, byte typeCode) {
    super(messageId, applicationID, messageData, typeCode);
  }
  
  public PSLogMessage(int messageId, byte[] messageData) {
    super(messageId, 0, messageData, (byte)7);
    try {
      ByteBuffer buffer = ByteBuffer.wrap(messageData).order(ByteOrder.LITTLE_ENDIAN);
      this.source = buffer.getShort();
      int messageLength = 0xFFFF & buffer.getShort();
      byte[] strData = new byte[messageLength];
      buffer.get(strData, 0, messageLength);
      this.message = new String(strData, StandardCharsets.UTF_8);
    } catch (Exception e) {
      e.printStackTrace();
      throw new IllegalArgumentException();
    } 
  }
  
  protected byte[] getMessageDataBytes() throws MessageFormatException {
    return this.data;
  }
  
  public synchronized short getSource() {
    return this.source;
  }
  
  public synchronized String getMessage() {
    return this.message;
  }
}
