package ubiik.wp.model.messages;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSMulticastDownlink extends PSDownlink {
  public PSMulticastDownlink(int applicationID, byte[] messageData, byte[] target, int endpoint) {
    super(applicationID, messageData, target, endpoint);
    setTypeCode((byte)3);
    setBytesForTarget(2);
  }
  
  public PSMulticastDownlink(int messageID, int applicationID, byte[] messageData, byte[] target) {
    super(applicationID, messageData, target);
    setTypeCode((byte)3);
    setBytesForTarget(2);
  }
  
  public PSMulticastDownlink(byte[] messageData, byte[] target, int endpoint) {
    super(messageData, target, endpoint);
    setTypeCode((byte)3);
    setBytesForTarget(2);
  }
  
  public PSMulticastDownlink(byte[] messageData, byte[] target) {
    super(messageData, target);
    setTypeCode((byte)3);
    setBytesForTarget(2);
  }
  
  public String getTargetString() {
    int multicastGroup = 0xFFFF & ByteBuffer.wrap(this.target).order(ByteOrder.LITTLE_ENDIAN).getShort();
    return "Multicast group " + multicastGroup;
  }
}
