package ubiik.wp.model.messages;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSNakMessage extends PSMessageResponse {
  private short errorCode;
  
  public PSNakMessage(int messageIDtoACK) {
    super(messageIDtoACK, (byte)11);
    this.messageIDtoACK = messageIDtoACK;
  }
  
  public PSNakMessage(byte[] data, int messageId) {
    this.messageId = messageId;
    try {
      ByteBuffer buffer = ByteBuffer.wrap(data).order(ByteOrder.LITTLE_ENDIAN);
      this.messageIDtoACK = 0xFFFF & buffer.getShort();
      this.errorCode = buffer.getShort();
    } catch (Exception e) {
      throw new IllegalArgumentException();
    } 
  }
  
  protected byte[] getMessageDataBytes() throws MessageFormatException {
    ByteBuffer buffer = ByteBuffer.allocate(2);
    buffer.order(ByteOrder.LITTLE_ENDIAN);
    buffer.putShort((short)(this.messageIDtoACK & 0xFFFF));
    buffer.putShort(this.errorCode);
    return buffer.array();
  }
  
  public short getErrorCode() {
    return this.errorCode;
  }
}
