package ubiik.wp.model.messages.pscommands;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public abstract class PSCommandChannelList extends PSCommand {
  public static final int BYTES_FOR_CHANNEL = 2;
  
  private int[] channels;
  
  public PSCommandChannelList(int[] channels, PSCommandDelegate delegate, short commandType) {
    super((byte[])null, commandType, delegate);
    this.channels = channels;
    setUpData(channels);
  }
  
  public void setChannels(int[] channels) {
    this.channels = channels;
    setUpData(channels);
  }
  
  public int[] getChannel() {
    return this.channels;
  }
  
  private void setUpData(int[] channels) {
    ByteBuffer buffer = ByteBuffer.allocate(2 + 2 * channels.length).order(ByteOrder.LITTLE_ENDIAN);
    buffer.putShort((short)channels.length);
    for (int channel : channels)
      buffer.putShort((short)channel); 
    this.data = buffer.array();
  }
  
  public String getContentString() {
    String content = "";
    for (int channel : this.channels)
      content = content + content + " "; 
    return content;
  }
}
