package ubiik.wp.model.messages.pscommands;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import ubiik.wp.model.fpga.FPGARegister;

public class PSCommandFPGASetRegister extends PSCommand {
  public PSCommandFPGASetRegister(FPGARegister register, PSCommandDelegate delegate) {
    super((byte[])null, (short)11, delegate);
    this
      
      .data = ByteBuffer.allocate(5).order(ByteOrder.LITTLE_ENDIAN).put((byte)(0xFF & register.getIndex())).putInt(register.getAs32Bit()).array();
  }
  
  public String getTypeString() {
    return "FPGA Set Register";
  }
  
  public String getContentString() {
    return "Register #" + Integer.toString(this.data[0]);
  }
}
