package ubiik.wp.model.messages.pscommands;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSCommandFrequencyScan extends PSCommand {
  private short startWARFCN;
  
  private short stopWARFCN;
  
  private short stepWARFCN;
  
  private short timeWindow;
  
  private short totalWindows;
  
  public PSCommandFrequencyScan(PSCommandDelegate delegate, short startWARFCN, short stopWARFCN, short stepWARFCN, short timeWindow, short totalWindows) {
    super((byte[])null, (short)24, delegate);
    this.startWARFCN = startWARFCN;
    this.stopWARFCN = stopWARFCN;
    this.stepWARFCN = stepWARFCN;
    this.timeWindow = timeWindow;
    this.totalWindows = totalWindows;
    setUpData();
  }
  
  public String getTypeString() {
    return "Scan WARFCN";
  }
  
  public String getContentString() {
    return "from " + this.startWARFCN + " to " + this.stopWARFCN;
  }
  
  private void setUpData() {
    this
      
      .data = ByteBuffer.allocate(10).order(ByteOrder.LITTLE_ENDIAN).putShort(this.startWARFCN).putShort(this.stopWARFCN).putShort(this.stepWARFCN).putShort(this.timeWindow).putShort(this.totalWindows).array();
  }
}
