package ubiik.wp.model.messages.pscommands;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import ubiik.utils.DatatypeConverter;

public class PSCommandGetScheduleTransfer extends PSCommand {
  private byte[] deviceUuid;
  
  public PSCommandGetScheduleTransfer(PSCommandDelegate delegate, byte[] deviceUuid) {
    super(new byte[0], (short)19, delegate);
    this.deviceUuid = deviceUuid;
    setUpData();
  }
  
  private void setUpData() {
    int buffLen = 16;
    ByteBuffer buffer = ByteBuffer.allocate(buffLen).order(ByteOrder.LITTLE_ENDIAN);
    buffer.put(this.deviceUuid);
    this.data = buffer.array();
  }
  
  public String getContentString() {
    return DatatypeConverter.printHexBinary(this.deviceUuid);
  }
  
  public String getTypeString() {
    return "Set Schedule Transfer";
  }
  
  public byte[] getDeviceUuid() {
    return this.deviceUuid;
  }
}
