package ubiik.wp.model.messages.pscommands;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

public class PSCommandStringParameter extends PSCommandWithOperations {
  public static final int BYTES_FOR_CONTENT_LEN = 2;
  
  public static final String PARAMETER_TEST_MODES = "TEST_MODES";
  
  private String parameter;
  
  private String content;
  
  public PSCommandStringParameter(PSCommandDelegate delegate, String parameter, String content, byte operation) {
    super((byte[])null, (short)21, delegate, operation);
    this.parameter = parameter;
    this.content = content;
    if (operation == 1 && content == null)
      throw new IllegalArgumentException(); 
    if (this.content == null)
      this.content = new String(); 
    setUpData();
  }
  
  private void setUpData() {
    byte[] contentData = this.content.getBytes();
    ByteBuffer buffer = ByteBuffer.allocate(35 + contentData.length).order(ByteOrder.LITTLE_ENDIAN);
    buffer.put(getStringBytesWithPadding(this.parameter))
      .put(this.operation)
      .putShort((short)contentData.length)
      .put(contentData);
    this.data = buffer.array();
  }
  
  public String getContentString() {
    return this.content;
  }
  
  public String getTypeString() {
    String str = super.getTypeString();
    str = str.concat(" ").concat(this.parameter);
    return str;
  }
  
  public String getParameter() {
    return this.parameter;
  }
}
