package ubiik.wp.model.messages.pscommands.responses;

import java.util.Arrays;
import ubiik.wp.model.messages.pscommands.PSCommand;

public abstract class PSCommandResponse extends PSCommand {
  public static final byte COMMAND_RESPONSE_SUCCESS = 0;
  
  public static final int BYTES_FOR_COMMAND_RESPONSE_STATUS = 1;
  
  private byte errorCode;
  
  public PSCommandResponse(int messageId, int commandId, byte[] commandData, short commandType) {
    super(messageId, commandId, commandData, commandType, (byte)-124);
    try {
      this.errorCode = commandData[0];
    } catch (Exception e) {
      throw new IllegalArgumentException();
    } 
  }
  
  public byte getErrorCode() {
    return this.errorCode;
  }
  
  public boolean isSuccess() {
    return (this.errorCode == 0);
  }
  
  public byte[] getCommandResponseData() {
    if (this.data.length > 1)
      return Arrays.copyOfRange(this.data, 1, this.data.length); 
    return new byte[0];
  }
  
  public boolean compareResponseData(PSCommandResponse other) {
    boolean equal = false;
    if (other != null && 
      this.errorCode == other.getErrorCode())
      equal = doCompareResponseData(other); 
    return equal;
  }
  
  protected abstract boolean doCompareResponseData(PSCommandResponse paramPSCommandResponse);
}
