package ubiik.wp.model.testmode;

import java.util.ArrayList;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

public class TestModeFactory {
  public ArrayList<UUTestMode> loadTestModes(String jsonTestModes) {
    ArrayList<UUTestMode> tesModes = new ArrayList<>();
    JSONParser jsonParser = new JSONParser();
    try {
      JSONObject root = (JSONObject)jsonParser.parse(jsonTestModes);
      try {
        JSONArray testModesArray = (JSONArray)root.get("test_modes");
        for (Object catObject : testModesArray) {
          JSONObject catJObject = (JSONObject)catObject;
          String category = (String)catJObject.get("category");
          category = (category != null) ? category : "";
          JSONArray testsArray = (JSONArray)catJObject.get("tests");
          for (Object object : testsArray) {
            JSONObject jObject = (JSONObject)object;
            Long run_mode = (Long)jObject.get("run_mode");
            run_mode = Long.valueOf((run_mode != null) ? run_mode.longValue() : 0L);
            Long sub_mode = (Long)jObject.get("sub_mode");
            sub_mode = Long.valueOf((sub_mode != null) ? sub_mode.longValue() : 0L);
            String name = (String)jObject.get("name");
            name = (name != null) ? name : "";
            UUTestMode testMode = new UUTestMode(name, category, run_mode.intValue(), sub_mode.intValue());
            if (testMode != null)
              tesModes.add(testMode); 
          } 
        } 
      } catch (Exception e) {
        e.printStackTrace();
        System.err.println("Error parsing Test Mode");
      } 
    } catch (ParseException e1) {
      e1.printStackTrace();
    } 
    return tesModes;
  }
}
