package ubiik.wp.qa.model;

import java.util.concurrent.atomic.AtomicBoolean;
import ubiik.utils.communication.ProgressDelegate;
import ubiik.wp.ami.controller.UUTestResult;
import ubiik.wp.model.messages.PSUplink;

public abstract class BSTest implements Runnable {
  protected AtomicBoolean doRun;
  
  protected UUTestResult testResult;
  
  protected ProgressDelegate progressDelegate;
  
  public BSTest(ProgressDelegate progressDelegate) {
    this.doRun = new AtomicBoolean(false);
    this.testResult = new UUTestResult(false, "Not run");
    this.progressDelegate = progressDelegate;
  }
  
  public abstract void run();
  
  public UUTestResult getResult() {
    return this.testResult;
  }
  
  public void stop() {
    this.doRun.set(false);
  }
  
  public boolean running() {
    return this.doRun.get();
  }
  
  public void processUplink(PSUplink uplink) {}
}
