package ubiik.wp.qa.model.disturbance;

import java.util.Calendar;
import ubiik.utils.communication.ProgressDelegate;
import ubiik.wp.qa.model.BSTest;
import ubiik.wp.view.ConnectionManagerViewController;

public class ConnectionDisturbance extends BSTest {
  private ConnectionManagerViewController viewController;
  
  private long millisConnectedInterval;
  
  private long millisDisconnectedInterval;
  
  private boolean connected;
  
  public ConnectionDisturbance(ConnectionManagerViewController viewController, ProgressDelegate progressDelegate, long millisConnectedInterval, long millisDisconnectedInterval) {
    super(progressDelegate);
    this.millisConnectedInterval = millisConnectedInterval;
    this.millisDisconnectedInterval = millisDisconnectedInterval;
    this.connected = true;
    this.viewController = viewController;
  }
  
  public void run() {
    this.doRun.set(true);
    long timeRunning = 0L;
    long start = Calendar.getInstance().getTime().getTime();
    while (this.doRun.get()) {
      timeRunning = Calendar.getInstance().getTime().getTime() - start;
      if (this.connected) {
        if (this.millisConnectedInterval < timeRunning) {
          this.viewController.disconnect();
          this.connected = false;
          start = Calendar.getInstance().getTime().getTime();
        } 
      } else if (this.millisDisconnectedInterval < timeRunning) {
        this.viewController.connect();
        this.connected = true;
        start = Calendar.getInstance().getTime().getTime();
      } 
      try {
        Thread.sleep(100L);
      } catch (InterruptedException e) {
        this.doRun.set(false);
        e.printStackTrace();
      } 
    } 
  }
}
