package ubiik.wp.qa.model.disturbance;

import java.util.Calendar;
import java.util.List;
import ubiik.utils.DatatypeConverter;
import ubiik.utils.communication.ProgressDelegate;
import ubiik.utils.model.ByteArrayUtils;
import ubiik.wp.controller.MessageController;
import ubiik.wp.model.messages.PSDownlink;
import ubiik.wp.model.messages.PSMessage;
import ubiik.wp.qa.model.BSTest;

public class DownlinksDisturbance extends BSTest {
  private static final byte NO_APP_TYPE = 68;
  
  private long millisInterval;
  
  private int payloadSize;
  
  private MessageController messageController;
  
  private List<String> uuids;
  
  public DownlinksDisturbance(ProgressDelegate progressDelegate, MessageController messageController, long millisInterval, int payloadSize, List<String> uuids) {
    super(progressDelegate);
    this.messageController = messageController;
    this.millisInterval = millisInterval;
    this.uuids = uuids;
    this.payloadSize = payloadSize;
  }
  
  public void run() {
    this.doRun.set(true);
    long start = Calendar.getInstance().getTime().getTime();
    long timeRunning = 0L;
    while (this.doRun.get()) {
      timeRunning = Calendar.getInstance().getTime().getTime() - start;
      if (timeRunning > this.millisInterval) {
        start = Calendar.getInstance().getTime().getTime();
        for (String uuid : this.uuids) {
          byte[] randData = ByteArrayUtils.getRandomApplicationData(this.payloadSize, Byte.valueOf((byte)68));
          System.out.println("Send Downlink: " + DatatypeConverter.printHexBinary(randData));
          this.messageController.sendMessage((PSMessage)new PSDownlink(randData, 
                DatatypeConverter.parseHexBinary(uuid)));
        } 
      } 
      try {
        Thread.sleep(100L);
      } catch (InterruptedException e) {
        this.doRun.set(false);
        e.printStackTrace();
      } 
    } 
  }
}
